import * as widgets from '@jupyter-widgets/base';
import * as d3 from 'd3';
import { Figure } from './Figure';
import { Tooltip } from './Tooltip';
import { Scale } from './Scale';
export declare class MarketMap extends Figure {
    protected renderImpl(): Promise<[void, widgets.DOMWidgetView[]]>;
    set_top_el_style(): void;
    update_plotarea_dimensions(): void;
    reset_drawing_controls(): void;
    create_listeners(): void;
    update_title(model: any, value: any): void;
    relayout(): void;
    update_data(): void;
    update_domains(): void;
    set_area_dimensions(num_items: any): void;
    compute_dimensions_and_draw(): void;
    update_default_tooltip(): void;
    create_scale_views(): Promise<void>;
    set_scales(): void;
    show_groups(model: any, value: any): void;
    draw_map(): void;
    draw_group_names(): void;
    recolor_chart(): void;
    update_font_style(): void;
    update_map_colors(): void;
    cell_click_handler(data: any, id: any, cell: any): void;
    apply_selected(): void;
    clear_selected(): void;
    mouseover_handler(data: any, id: any, cell: any): void;
    update_selected_stroke(model: any, value: any): void;
    update_hovered_stroke(model: any, value: any): void;
    mouseout_handler(data: any, id: any, cell: any): void;
    show_tooltip(event: any, data: any): void;
    mousemove_handler(): void;
    move_tooltip(): void;
    hide_tooltip(): void;
    create_tooltip_widget(): void;
    get_group_transform(index: any): string;
    get_cell_transform(index: any): string;
    get_new_cords(): number[];
    past_border_y(): boolean;
    past_border_x(): boolean;
    colors_updated(): void;
    get_color(index: any, length: any): string;
    set_row_limits(): void;
    get_end_points(group_iter: any, num_cells: any, start_col: any, start_row: any, x_direction: any, y_direction: any): any[];
    create_bounding_path(elem: any, end_points: any): d3.Selection<SVGPathElement, unknown, null, undefined>;
    calc_end_point_source(curr_x: any, curr_y: any, x_direction: any, y_direction: any): {
        x: number;
        y: number;
    }[];
    calc_end_point_dest(curr_x: any, curr_y: any, x_direction: any, y_direction: any): {
        x: number;
        y: number;
    }[];
    scales: {
        [key: string]: Scale;
    };
    num_rows: number;
    num_cols: number;
    row_groups: number;
    enable_select: boolean;
    data: string[];
    fig_map: d3.Selection<SVGGElement, any, any, any>;
    fig_click: d3.Selection<SVGGElement, any, any, any>;
    fig_hover: d3.Selection<SVGGElement, any, any, any>;
    fig_names: d3.Selection<SVGGElement, any, any, any>;
    selected_stroke: string;
    hovered_stroke: string;
    column_width: number;
    row_height: number;
    prev_x: number;
    prev_y: number;
    y_direction: number;
    x_direction: number;
    group_iter: number;
    ref_data: any[];
    group_data: number[];
    groups: any[];
    colors: string[];
    colors_map: any;
    grouped_data: {
        [key: string]: {
            [key: string]: any;
        }[];
    };
    running_sums: number[];
    tooltip_fields: (number | string)[];
    tooltip_formats: ((d: number | string) => number | string)[];
    rect_groups: d3.Selection<d3.BaseType, any, SVGGraphicsElement, any>;
    end_points: number[];
    tooltip_view: Tooltip;
    row_limits: number[];
}
